config/urls.py
# -*- coding: utf-8 -*-


from django.views.generic import TemplateView
from django.views import defaults as default_views
from django.conf import settings
from django.conf.urls.static import static
from django.urls import include, path, re_path
from .views import HomePageView
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from wagtail.contrib.sitemaps.views import sitemap as sitemap_wagtail
from wagtail import urls as wagtail_urls
from wagtail.admin import urls as wagtailadmin_urls
from wagtail.documents import urls as wagtaildocs_urls
from wagtail.images.views.serve import ServeView


from config.sitemaps import ArtefactSitemap, HomePageSitemap

sitemaps = {
    'artefact': ArtefactSitemap,
    'home': HomePageSitemap,
}

urlpatterns = [
    re_path(r'^$', HomePageView.as_view(), name="home"),

    # Uncomment the next line to enable the admin:
    path(settings.ADMIN_URL, admin.site.urls),

    # User management
    re_path(r'^users/', include("users.urls", namespace="users")),
    re_path(r'^accounts/', include('allauth.urls')),
    path('captcha/', include('captcha.urls')),

    # Uncomment the next line to enable avatars
    re_path(r'^avatar/', include('avatar.urls')),

    # Newsletter
    #re_path(r'^newsletter/', include('newsletter.urls')),
    re_path(r'^tinymce/', include('tinymce.urls')),

    # Envelope (contact form)
    #re_path(r'^contact/', include('envelope.urls')),

    # Your stuff: custom urls go here
    #re_path(r'^dev/', include('deployment.urls')),

    # Artefacts management
    re_path(r'^artefacts/', include('artefacts.urls')),

    # Contacts management
    re_path(r'^contacts/', include('contacts.urls')),

    # Django-terms app
    # re_path(r'^terms/', include('terms.urls')),

    # Sitemaps
    re_path(r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
    name='django.contrib.sitemaps.views.sitemap'),

    re_path(r'^sitemap-wagtail\.xml$', sitemap_wagtail),

    # Robots
    re_path(r'^robots\.txt', include('robots.urls')),

    # Stratigraphies
    re_path(r'^micorr/', include('stratigraphies.urls', namespace="stratigraphies")),
    re_path(r'^visual_inspection/', include('ifompat_manager.urls', namespace='ifompat_manager')),
    re_path(r'^reviews/', include('reviews.urls', namespace='reviews'))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    # This allows the error pages to be debugged during development, just visit
    # these url in browser to see how these error pages look like.
    import debug_toolbar
    urlpatterns += [
        re_path(r'^400/$', default_views.bad_request, kwargs={'exception': Exception('Bad Request!')}),
        re_path(r'^403/$', default_views.permission_denied, kwargs={'exception': Exception('Permission Denied')}),
        re_path(r'^404/$', default_views.page_not_found, kwargs={'exception': Exception('Page not Found')}),
        re_path(r'^500/$', default_views.server_error),
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ]

# Wagtail URLS
urlpatterns += [
    re_path(r'^w/admin/', include(wagtailadmin_urls)),
    re_path(r'^w/documents/', include(wagtaildocs_urls)),

    # For anything not caught by a more specific rule above, hand over to
    # Wagtail's serving mechanism
    re_path(r'^images/([^/]*)/(\d*)/([^/]*)/[^/]*$', ServeView.as_view(), name='wagtailimages_serve'),
    re_path(r'', include(wagtail_urls)),
]

micorr/contacts/urls.py
from django.urls import  re_path
from django.contrib.auth.decorators import login_required

from .views import ContactCreateView

app_name="contacts"

urlpatterns = [
    re_path(r'^create/$', login_required(ContactCreateView.as_view()), name='contact-create'),
]

micorr/reviews/urls.py
from rest_framework import routers
from django.urls import path, include, re_path

from .views import CannedTextTypeViewSet, CannedTextViewSet, ReviewLogViewSet, EditorReviewViewSet, PeerReviewViewSet, \
    PublicationViewSet, UserViewSet, NgReviewsAppView

router = routers.DefaultRouter()

app_name = "reviews"

router.register(r'canned_texts', CannedTextTypeViewSet)
router.register(r'canned_text_types', CannedTextViewSet)
router.register(r'review_logs', ReviewLogViewSet)
router.register(r'editor_reviews', EditorReviewViewSet, basename='editorreview')
router.register(r'peer_reviews', PeerReviewViewSet)
router.register(r'publications', PublicationViewSet)
router.register(f'reviewers', UserViewSet)

urlpatterns = [
    path('api/', include(router.urls)),
    re_path('^.*', NgReviewsAppView.as_view(), name='app'),
]

micorr/users/urls.py
# -*- coding: utf-8 -*-


from django.urls import  re_path

from . import views

app_name = 'users'

urlpatterns = [
    # URL pattern for the UserListView
    re_path(
        r'^$',
        view=views.UserListView.as_view(),
        name='list'
    ),

    # URL pattern for the UserRedirectView
    re_path(
        r'^~redirect/$',
        view=views.UserRedirectView.as_view(),
        name='redirect'
    ),

    # URL pattern for the UserDetailView
    re_path(
        r'^(?P<username>[\w.@+-]+)/$',
        view=views.UserDetailView.as_view(),
        name='detail'
    ),

    # URL pattern for the UserUpdateView
    re_path(
        r'^~update/$',
        view=views.UserUpdateView.as_view(),
        name='update'
    ),

]

micorr/artefacts/models.py
# coding=utf-8
import os
import uuid

from django.db import models
from django.contrib.contenttypes.fields import GenericForeignKey, GenericRelation
from django.contrib.contenttypes.models import ContentType
from contacts.models import Contact
from micorr.users.models import User
from django.conf import settings
from django_extensions.db.models import TimeStampedModel
from tinymce import models as tinymce_models
from cities_light.models import City

from artefacts import get_img_storage_path, get_img_storage_path_stratigraphy, get_doc_storage_path

from wagtail.snippets.models import register_snippet
from wagtail.admin.panels import FieldPanel

from .year_field import YearField


class Element(TimeStampedModel):
    symbol = models.CharField(max_length=2, blank=False, unique=True, help_text='Symbol of the element')
    name = models.CharField(max_length=50, blank=False, help_text='Name of the element')
    phase = models.CharField(max_length=10, blank=True, help_text='Natural phase of the element at room temperature')
    category = models.CharField(max_length=50, blank=True, help_text='Category of the element')
    number = models.IntegerField(blank=False, null=False, help_text='Atomic number of the element')

    def __str__(self):
        return self.symbol



class Alloy(TimeStampedModel):
    """
    The artefact alloy
    """
    order = models.IntegerField(blank=True, null=True, help_text='The purity of the metal. The lower, the purer the metal is')
    name = models.CharField(max_length=100, blank=True, help_text='The artefact alloy')

    class Meta:
        ordering = ['order', 'name']
        verbose_name = 'Alloy'
        verbose_name_plural = 'Alloys'

    def __str__(self):
        return self.name


class Type(TimeStampedModel):
    """
    What the artefact was used for
    """
    name = models.CharField(max_length=200, blank=True, help_text='What the artefact was used for')

    class Meta:
        ordering = ['name']
        verbose_name = 'Type'
        verbose_name_plural = 'Types'

    def __str__(self):
        return self.name


class Origin(TimeStampedModel):
    """
    Where the artefact was located
    """
    site = models.CharField(max_length=100, blank=True, verbose_name="site/object",
                            help_text='The place where the artefact was located or the object to which the section considered belongs to')
    city = models.ForeignKey(City, on_delete=models.deletion.CASCADE, blank=True, null=True, help_text='The city where the artefact was located (optional for objects)')

    def origin_verbose_description(self):
        origin = []
        if self.site:
            origin.append(self.site)
        if self.city:
            origin.append(self.city.name)
            origin.append(self.city.region.name)
            origin.append(self.city.country.name)
        return ", ".join(origin)

    class Meta:
        ordering = ['site']
        verbose_name = 'Origin'
        verbose_name_plural = 'Origins'

    def __str__(self):
        return self.origin_verbose_description()


class RecoveringDate(TimeStampedModel):
    """
    The date when the artefact was found
    """
    date = models.CharField(max_length=200, blank=True, help_text='The date when the artefact was found')

    class Meta:
        verbose_name = 'Recovering Date'
        verbose_name_plural = 'Recovering Dates'

    def __str__(self):
        return self.date


class ChronologyCategory(TimeStampedModel):
    """
    The dating of the artefact
    """
    order = models.IntegerField(blank=True, null=True, help_text='The category chronology')
    name = models.CharField(max_length=100, blank=True, help_text='The dating of the artefact')
    tpq = YearField(blank=True, default=0, help_text='Category TPQ (Terminus post quem) e.g. "3000 B.C."')
    taq = YearField(blank=True, default=0, help_text='Category TAQ (Terminus ante quem) e.g. "200 A.D."')

    class Meta:
        ordering = ['order']
        verbose_name = 'Chronology Category'
        verbose_name_plural = 'Chronology Categories'

    def __str__(self):
        return self.name




class Environment(TimeStampedModel):
    """
    What the burial conditions of the artefact were
    """
    name = models.CharField(max_length=100, blank=True, help_text='The burial conditions of the artefact')

    class Meta:
        ordering = ['name']
        verbose_name = 'Environment'
        verbose_name_plural = 'Environments'

    def __str__(self):
        return self.name


class Technology(TimeStampedModel):
    """
    The manufacturing techniques used
    """
    name = models.CharField(max_length=100, blank=True, help_text='The manufacturing techniques used')

    class Meta:
        ordering = ['name']
        verbose_name = 'Technology'
        verbose_name_plural = 'Technologies'

    def __str__(self):
        return self.name


class Microstructure(TimeStampedModel):
    """
    What the artefact is made of
    """
    name = models.CharField(max_length=100, blank=True)

    class Meta:
        ordering = ['name']
        verbose_name = 'Microstructure'
        verbose_name_plural = 'Microstructures'

    def __str__(self):
        return self.name


class CorrosionForm(TimeStampedModel):
    """
    The corrosion form observed
    """
    form = models.CharField(max_length=100, blank=True)

    class Meta:
        ordering = ['form']
        verbose_name = 'Corrosion Form'
        verbose_name_plural = 'Corrosion Forms'

    def __str__(self):
        return self.form


class CorrosionType(TimeStampedModel):
    """
    The corrosion type observed
    """
    type = models.CharField(max_length=100, blank=True)

    class Meta:
        ordering = ['type']
        verbose_name = 'Corrosion Type'
        verbose_name_plural = 'Corrosion Types'

    def __str__(self):
        return self.type

class Object(TimeStampedModel):
    """
    An object can be linked to more than one card (artefact)
    """
    name = models.CharField(max_length=100, verbose_name='name', blank=True, default='', help_text='Name of the object')
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.deletion.CASCADE, verbose_name="user's object", blank=True, null=True,
                             help_text='The user who entered the object into the database')

    class Meta:
        ordering = ['name']
        verbose_name = 'Object'
        verbose_name_plural = 'Objects'

    def __str__(self):
        return self.name if len(self.name) else '[blank]'

class Artefact(TimeStampedModel):
    """
    An artefact has many foreign keys, corresponding to its characteristics55
    """
    # Own fields
    """name = models.CharField(max_length=100, verbose_name='name', blank=True, default='', help_text='Name of the artefact')"""
    description = tinymce_models.HTMLField(verbose_name='description of artefact', blank=True, help_text='A short description of the artefact. Can also include its general appearance (colour, presence or not of a corrosion layer, missing parts, large cracks, etc.)')
    inventory_number = models.CharField(max_length=100, verbose_name='inv. Number', blank=True, default='', help_text='The inventory number of the artefact')
    recorded_conservation_data = models.CharField(max_length=500, blank=True, default='', help_text='A brief description of the conservation treatment applied if any with literature references (Names of authors, year)')
    sample_description = tinymce_models.HTMLField(verbose_name='description of sample', blank=True, default='', help_text='Information on the sample, the way it was obtained, its condition (presence or not of corrosion layers) and dimensions')
    sample_number = models.CharField(max_length=100, verbose_name='lab number of sample', blank=True, default='', help_text='The inventory number of the artefact sample')
    date_aim_sampling = models.CharField(max_length=200, verbose_name='date and aim of sampling', blank=True, default='', help_text='The date and aim of sampling')
    validated = models.BooleanField(null=True, default=None, blank=True)
    published = models.BooleanField(default=False)

    # Foreign Keys
    object = models.ForeignKey(Object, on_delete=models.deletion.CASCADE, verbose_name='object described', blank=True, null=True, help_text='Name of the artefact')
    author = models.ManyToManyField(Contact, verbose_name='authors', blank=True, related_name='artefacts', help_text='The author(s) of this file is (are) responsible for the information provided. Author(s) should provide after the abbreviation of their institution affiliation their last name and initial of their first name in brackets such as HE-Arc CR (Degrigny C.). Hold down "Control", or "Command" on a Mac, to select more than one')
    metal_e_1 = models.ForeignKey(Element, on_delete=models.deletion.CASCADE, verbose_name='first metal element', blank=True, null=True, related_name='first_metal_artefacts', help_text='The primary metal element of the artefact')
    metal_e_x = models.ManyToManyField(Element, verbose_name='other metal elements', blank=True, related_name='other_metal_artefacts', help_text='The other metal elements of the artefact, several elements can be selected by clicking on Ctrl + elements selected')
    alloy = models.ForeignKey(Alloy, on_delete=models.deletion.CASCADE, blank=True, null=True, help_text='The alloy the artefact is made of')
    type = models.ForeignKey(Type, on_delete=models.deletion.CASCADE, verbose_name='type of artefact', blank=True, null=True,
                             help_text='The name of the artefact, its typology')
    origin = models.ForeignKey(Origin, on_delete=models.deletion.CASCADE, blank=True, null=True, related_name='artefacts',
                               help_text='The place, city and country where the artefact comes from or the object to which the section considered belongs to')

micorr/users/models.py
# -*- coding: utf-8 -*-


from django.contrib.auth.models import AbstractUser
from django.urls import reverse
from django.db import models
from django.utils.translation import gettext_lazy as _


class User(AbstractUser):

    # First Name and Last Name do not cover name patterns
    # around the globe.
    name = models.CharField(_('Name of User'), blank=True, max_length=255)

    def __str__(self):
        return self.username

    def get_absolute_url(self):
        return reverse('users:detail', kwargs={'username': self.username})

micorr/contacts/forms.py
from django import forms
from django.urls import reverse_lazy

from .models import Contact
from cities_light.models import Country, City, Region
from dal import autocomplete


class ContactCreateForm(forms.ModelForm):
    """
    Create a new contact
    """
    # customize ModelChoiceField widgets to use dal autocomplete
    country = forms.ModelChoiceField(required=False,
                                  help_text=str(Contact._meta.get_field('country').help_text),
                                  queryset=Country.objects.all(),
                                  widget=autocomplete.ModelSelect2(url='artefacts:country-autocomplete')
                                  )
    region = forms.ModelChoiceField(required=False,
                                  help_text=str(Contact._meta.get_field('region').help_text),
                                  queryset=Region.objects.all(),
                                  widget=autocomplete.ModelSelect2(url='artefacts:region-autocomplete')
                                  )
    city = forms.ModelChoiceField(required=False,
                                  help_text=str(Contact._meta.get_field('city').help_text),
                                  queryset=City.objects.all(),
                                  widget=autocomplete.ModelSelect2(url='artefacts:city-autocomplete')
                                  )
    class Meta:
        model = Contact
        exclude = ['user', 'parent']

micorr/contacts/views.py
from django.views import generic
from .models import Contact
from .forms import ContactCreateForm


class ContactCreateView(generic.CreateView):
    """
    A view which allows the user to create a technology
    When the chronology is created, it redirects the user to the artefact list
    """
    model = Contact
    template_name_suffix = '_create_form'
    form_class = ContactCreateForm

micorr/templates/newsletter/newsletter_detail.html
{% extends "base.html" %}

{% load i18n %}


{% block title %}{% trans "Newsletter detail" %}{% endblock title %}

{% block content %}
<table>
    <tr>
        <th>{% trans "Newsletter" %} {{ object.title }}</th>
    </tr>
    <tr>
        <td><a href="{% url "newsletter_subscribe_request" object.slug %}">Subscribe</a></td>
    </tr>
    {% if not user.is_authenticated %}
    <tr>
        <td><a href="{% url "newsletter_update_request" object.slug %}">Update</a></td>
    </tr>
    {% endif %}
    <tr>
        <td><a href="{% url "newsletter_unsubscribe_request" object.slug %}">Unsubscribe</a></td>
    </tr>
    <tr>
        <td><a href="{% url "newsletter_archive" object.slug %}">Archive</a></td>
    </tr>
    <tr>
        <td><a href="../">Back to list</a></td>
    </tr>
</table>
{% endblock content %}

micorr/templates/newsletter/newsletter_list.html
{% extends "base.html" %}

{% load i18n %}


{% block title %}{% trans "Newsletter list" %}{% endblock title %}

{% block content %}
{% if user.is_authenticated %}
<form method="POST" action="">
  {% csrf_token %}
  {{ formset.management_form }}
  <table>
    <tr>
        <th>{% trans "Newsletter" %}</th>
        {% if user %}
        <th>{% trans "Subscribe" %}</th>
        {% endif %}
    </tr>
    {% for form in formset.forms %}
      <tr>
        <td>{{ form.id }}{{ form.newsletter }}
<a href="{% url "newsletter_detail" form.instance.newsletter.slug %}">{{ form.instance.newsletter.title }}</a></td>
        <td>{{ form.subscribed }}</td>
      </tr>
    {% endfor %}
  </table>
  <p><input id="id_submit" name="submit" value="{% trans "Update subscriptions" %}" type="submit" /></p>
</form>
{% else %}
<table>
    <tr>
        <th>{% trans "Newsletter" %}</th>
    </tr>
    {% for newsletter in object_list %}
    <tr>
        <td><a href="{% url "newsletter_detail" newsletter.slug %}">{{ newsletter.title }}</a></td>
    </tr>
    {% endfor %}
</table>
{% endif %}
{% endblock content %}

micorr/templates/newsletter/submission_archive.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter archive" %}{% endblock title %}

{% block content %}
<table>
    <tr>
        <th>{% trans "Newsletter archive" %} {{ newsletter.title }}</th>
    </tr>
    {% for submission in latest %}
    <tr>
        <td><a href="{{ submission.get_absolute_url }}">{{ submission }}</a></td>
    </tr>
    {% endfor %}
    <tr>
        <td><a href="../">Back to list</a></td>
    </tr>
</table>
{% endblock content %}

micorr/templates/newsletter/subscription_activate.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}</h1>

    <form enctype="multipart/form-data" method="post" action=".">
        {% csrf_token %}
        {{ form.as_p }}
        <p><input id="id_submit" name="submit" value="{% trans "Activate" %}" type="submit" /></p>
    </form>
{% endblock content %}

micorr/templates/newsletter/subscription_subscribe.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter subscribe" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter subscribe" %} {{ newsletter.title }}</h1>

    {% if error %}
        <p>{% trans "Due to a technical error we were not able to submit your confirmation email. This could be because your email address is invalid." %}</p>

        {% comment %} Replace the the following dummy with a valid email address and remove this comment.

        <p>{% trans "If the error persists, please don't hesitate to contact us at the following email address:" %} <a href="mailto:info@foobar.com">info@foobar.com</a></p>

        {% endcomment %}
    {% else %}
        <form enctype="multipart/form-data" method="post" action=".">
            {% csrf_token %}
            {{ form.as_p }}
            <p><input id="id_submit" name="submit" value="{% trans "Subscribe" %}" type="submit" /></p>
        </form>
    {% endif %}
{% endblock content %}

micorr/templates/newsletter/subscription_subscribe_activated.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}</h1>

    <p>{% trans "Your subscription has successfully been activated." %}</p>
{% endblock content %}

micorr/templates/newsletter/subscription_subscribe_email_sent.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter subscribe" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter subscribe" %} {{ newsletter.title }}</h1>

    <p>{% trans "Your subscription request was successfully received and an activation email has been sent to you. In that email you will find a link which you need to follow in order to activate your subscription." %}</p>
{% endblock content %}

micorr/templates/newsletter/subscription_subscribe_user.html
{% extends "base.html" %}

{% load i18n %}


{% block title %}{% trans "Newsletter subscribe" %}{% endblock title %}

{% block content %}
<h1>{% trans "Newsletter subscribe" %} {{ newsletter.title }}</h1>

<p>Welcome, {{ user }}!</p>

{% if messages %}
<ul>
    {% for message in messages %}
    <li>{{ message }}</li>
    {% endfor %}
</ul>
{% else %}
{% trans "Do you want to subscribe to this newsletter?" %}
<form enctype="multipart/form-data" method="post" action="{% url "newsletter_subscribe_confirm" newsletter.slug %}">
    {% csrf_token %}
    <p><input id="id_submit" name="submit" value="{% trans "Subscribe" %}" type="submit" /></p>
</form>
{% endif %}
{% endblock content %}

micorr/templates/newsletter/subscription_unsubscribe.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter unsubscribe" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter unsubscribe" %} {{ newsletter.title }}</h1>

    {% if error %}
        <p>{% trans "Due to a technical error we were not able to submit your confirmation email. This could be because your email address is invalid." %}</p>

        {% comment %} Replace the the following dummy with a valid email address and remove this comment.

        <p>{% trans "If the error persists, please don't hesitate to contact us at the following email address:" %} <a href="mailto:info@foobar.com">info@foobar.com</a></p>

        {% endcomment %}
    {% else %}
        <form enctype="multipart/form-data" method="post" action=".">
            {% csrf_token %}
            {{ form.as_p }}
            <p><input id="id_submit" name="submit" value="{% trans "Unsubscribe" %}" type="submit" /></p>
        </form>
    {% endif %}
{% endblock content %}

micorr/templates/newsletter/subscription_unsubscribe_activated.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}</h1>

    <p>{% trans "You have successfully been unsubscribed." %}</p>
{% endblock content %}

micorr/templates/newsletter/subscription_unsubscribe_email_sent.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter unsubscribe" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter unsubscribe" %} {{ newsletter.title }}</h1>

    <p>{% trans "Your unsubscription request has successfully been received. An email has been sent to you with a link you need to follow in order to confirm your unsubscription." %}</p>
{% endblock content %}

micorr/templates/newsletter/subscription_unsubscribe_user.html
{% extends "base.html" %}

{% load i18n %}


{% block title %}{% trans "Newsletter unsubscribe" %}{% endblock title %}

{% block content %}
<h1>{% trans "Newsletter unsubscribe" %} {{ newsletter.title }}</h1>

<p>Welcome, {{ user }}!</p>

{% if messages %}
<ul>
    {% for message in messages %}
    <li>{{ message }}</li>
    {% endfor %}
</ul>
{% else %}

{% trans "Do you want to unsubscribe from this newsletter?" %}
<form enctype="multipart/form-data" method="post" action="{% url "newsletter_unsubscribe_confirm" newsletter.slug %}">
    {% csrf_token %}
    <p><input id="id_submit" name="submit" value="{% trans "Unsubscribe" %}" type="submit" /></p>
</form>
{% endif %}

{% endblock content %}

micorr/templates/newsletter/subscription_update_activated.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter" %} {{ newsletter.title }} {{ action }} {% trans "activate" %}</h1>

    <p>{% trans "Your subscription has successfully been updated." %}</p>
{% endblock content %}

micorr/templates/newsletter/subscription_update_email_sent.html
{% extends "base.html" %}

{% load i18n %}

{% block title %}{% trans "Newsletter update" %}{% endblock title %}

{% block content %}
    <h1>{% trans "Newsletter update" %} {{ newsletter.title }}</h1>

    <p>{% trans "Your update request was successfully received and an activation email has been sent to you. In that email you will find a link which you need to follow in order to update your subscription." %}</p>
{% endblock content %}